"use strict";function invariant(t,i){if(!t)throw new Error(i)}function withDefault(t,i){return void 0!==t?t:i}Object.defineProperty(exports,"__esModule",{value:!0});var classCallCheck=function(t,i){if(!(t instanceof i))throw new TypeError("Cannot call a class as a function")},createClass=function(){function t(t,i){for(var e=0;e<i.length;e++){var n=i[e];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(t,n.key,n)}}return function(i,e,n){return e&&t(i.prototype,e),n&&t(i,n),i}}(),_extends=Object.assign||function(t){for(var i=1;i<arguments.length;i++){var e=arguments[i];for(var n in e)Object.prototype.hasOwnProperty.call(e,n)&&(t[n]=e[n])}return t},Spring=function(){function t(){var i=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{};classCallCheck(this,t),this._listeners=[],this._currentTime=0,this._springTime=0,this._currentNormalizedPosition=0,this._currentNormalizedVelocity=0,this._springAtRest=!0,this._oscillationVelocityPairs=[],this._config={fromValue:withDefault(i.fromValue,0),toValue:withDefault(i.toValue,0),stiffness:withDefault(i.stiffness,100),damping:withDefault(i.damping,10),mass:withDefault(i.mass,1),initialVelocity:withDefault(i.initialVelocity,0),overshootClamping:withDefault(i.overshootClamping,!1),allowsOverdamping:withDefault(i.allowsOverdamping,!1),restVelocityThreshold:withDefault(i.restVelocityThreshold,.001),restDisplacementThreshold:withDefault(i.restDisplacementThreshold,.001)}}return createClass(t,[{key:"start",value:function(){var t=this,i=this._config,e=i.fromValue,n=i.toValue,s=i.initialVelocity;e===n&&0===s||(this._springTime=0,this._springAtRest=!1,this._currentAnimationStep||(this._currentAnimationStep=requestAnimationFrame(function(i){t._notifyListeners("onActive"),t._step(i)})))}},{key:"stop",value:function(){this._springAtRest||(this._notifyListeners("onAtRest"),this._springAtRest=!0,this._currentAnimationStep&&(cancelAnimationFrame(this._currentAnimationStep),this._currentAnimationStep=void 0))}},{key:"updateConfig",value:function(t){this._config.fromValue=this.position,this._config=_extends({},this._config,t),this.start()}},{key:"onActive",value:function(t){return this._listeners.push({onActive:t}),this}},{key:"onUpdate",value:function(t){return this._listeners.push({onUpdate:t}),this}},{key:"onAtRest",value:function(t){return this._listeners.push({onAtRest:t}),this}},{key:"_notifyListeners",value:function(t){var i=this;this._listeners.forEach(function(e){var n=e[t];"function"==typeof n&&n(i)})}},{key:"_step",value:function(t){var i=this;this._currentTime||(this._currentTime=t);var e=t-this._currentTime;this._evaluateSpring(e),this._currentTime=t,this._springAtRest||(this._currentAnimationStep=requestAnimationFrame(function(t){return i._step(t)}))}},{key:"_evaluateSpring",value:function(i){i>t.MAX_DELTA_TIME_MS&&(i=t.MAX_DELTA_TIME_MS),this._springTime+=i;var e=this._config.damping,n=this._config.mass,s=this._config.stiffness,r=this._config.fromValue,o=this._config.toValue,a=this._config.initialVelocity,h=0;r!==o&&(h=-a/(o-r)),invariant(n>0,"Mass value must be greater than 0"),invariant(s>0,"Stiffness value must be greater than 0"),invariant(e>0,"Damping value must be greater than 0");var l=e/(2*Math.sqrt(s*n)),u=Math.sqrt(s/n)/1e3,c=u*Math.sqrt(1-l*l),f=u*Math.sqrt(l*l-1);l>1&&!this._config.allowsOverdamping&&(l=1);var _=0,p=0,g=this._springTime;if(l<1){var m=Math.exp(-l*u*g);_=1-m*((h+l*u*1)/c*Math.sin(c*g)+1*Math.cos(c*g)),p=l*u*m*(Math.sin(c*g)*(h+l*u*1)/c+1*Math.cos(c*g))-m*(Math.cos(c*g)*(h+l*u*1)-1*c*Math.sin(c*g))}else if(1===l){var v=Math.exp(-u*g);_=1-v*(1+(h+1*u)*g),p=v*(h*(g*u-1)+1*g*(u*u))}else{var y=Math.exp(-l*u*g);_=1-y*((h+l*u*1)*Math.sinh(f*g)+1*f*Math.cosh(f*g))/f,p=y*l*u*(Math.sinh(f*g)*(h+l*u*1)+1*f*Math.cosh(f*g))/f-y*(f*Math.cosh(f*g)*(h+l*u*1)+f*f*1*Math.sinh(f*g))/f}if(this._currentNormalizedPosition=_,this._currentNormalizedVelocity=p,this._notifyListeners("onUpdate"),!this._springAtRest)return this._isSpringOvershooting(_)||this._isSpringAtRest(_,p)?(0!==s&&(this._currentNormalizedPosition=1,this._currentNormalizedVelocity=0,this._notifyListeners("onUpdate")),void this.stop()):void 0}},{key:"_isSpringOvershooting",value:function(t){var i=this._config,e=i.stiffness,n=!1;return i.overshootClamping&&0!==e&&(n=t>1),n}},{key:"_isSpringAtRest",value:function(t,i){var e=this._config,n=e.stiffness,s=e.restDisplacementThreshold,r=e.restVelocityThreshold,o=Math.abs(i)<=r;return 0!==n&&Math.abs(1-t)<=s&&o}},{key:"position",get:function(){var t=this._config.toValue-this._config.fromValue;return this._config.fromValue+this.normalizedPosition*t}},{key:"velocity",get:function(){var t=this._config.toValue-this._config.fromValue;return this.normalizedVelocity*t}},{key:"normalizedPosition",get:function(){return this._currentNormalizedPosition}},{key:"normalizedVelocity",get:function(){return this._currentNormalizedVelocity}}]),t}();Spring.MAX_DELTA_TIME_MS=1/60*1e3*4,exports.Spring=Spring;
//# sourceMappingURL=wobble.cjs.js.map
